 
package pl.malinowski.sharedViews.handlers;

import javax.inject.Named;

import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.ui.model.application.MApplication;
import org.eclipse.e4.ui.model.application.ui.advanced.MPerspective;
import org.eclipse.e4.ui.model.application.ui.basic.MWindow;
import org.eclipse.e4.ui.model.application.ui.menu.MHandledToolItem;
import org.eclipse.e4.ui.model.application.ui.menu.MToolBar;
import org.eclipse.e4.ui.model.application.ui.menu.MToolBarElement;
import org.eclipse.e4.ui.workbench.modeling.EModelService;
import org.eclipse.e4.ui.workbench.modeling.EPartService;

public class PerspectiveHandler 
{
	@Execute
	public void execute(@Named("pl.malinowski.sharedviews.commandparameter.perspectives") String perspectiveId,
						EModelService modelService, MApplication application, EPartService partService) 
	{
		MWindow window = application.getChildren().get(0);
		MPerspective perspective = modelService.getActivePerspective(window);
		if (perspective.getElementId().equals(perspectiveId)) return;
		
		perspective = (MPerspective)modelService.find(perspectiveId, application);
		partService.switchPerspective(perspective);
		
		MToolBar toolBar = (MToolBar)modelService.find("pl.malinowski.sharedviews.toolbar.perspectives", window);
		
		for (MToolBarElement element : toolBar.getChildren())
		{
			if (element instanceof MHandledToolItem)
			{
				((MHandledToolItem) element).setSelected(false);
				if (((MHandledToolItem) element).getLabel().equals(perspective.getLabel()))
					((MHandledToolItem) element).setSelected(true);
			}
		}
	}
		
}